DIM ver$(100)

'------------------------------------------------------------------------------
' "HTTP triger, (c)2007 Barix AG
' Jan Jeronym Zvanovec
' v0.09 24.02.2009	AC	! webinterface fixed
' v0.10 15.07.2010	AC	! udp syntax fixed
' v0.11 20.08.2010	AC	! protocol query changed from ptmp1<>0 to ptmp1=1
' v0.12 		AC	! added delay
' v0.13 13.05.2011	SG	! added command send for high/low input state, 
'				  check for empty config line (proto=2) and switch for local input8/relay 1
' v0.13a 16.10.2018	SG	! added function local relay on local input, removed input 8 /relay function
' v0.13c 13.02.2019	SG	! add serial message + special char for 0x13
' v1.0   10.08.2022 SG  ! add local command and rs232/rs485 + delay and &26
' v1.01  02.08.2024 SG  ! add configurable string termination character for UDP, TCP and serial
'------------------------------------------------------------------------------

ver$="V1.01 02.08.2024 with serial & local"

DIM pport$(50),ppath$,padr$,buf$,msg$(30),s1$(100),s2$(100),term$ (3)
DIM ptmp1,ptmp2,trigd,l,i,b,uu,cp,mlen,T2,pos,temp,dlay
DIM proto 	'0-http,1-udp,2-rs232,3-tcp,4-rs485,5-local,6-no entry 
DIM stats(7)
DIM oldstats(7)

'---------------------------------------------------------------------------
'---------------------------------------------------------------------------

SYSLOG "HTTP-/UDP-Trigger, (c) Barix AG"
SYSLOG "Version: "+ver$

'----------------------------------------------------------------------

' initialize stats array
 FOR i=0 to 7
 oldstats(i)=IOSTATE(201+i)
 NEXT i

' keep testing inputs
1
FOR i = 0 to 7
 stats(i)=IOSTATE(201+i)
 IF oldstats(i)<>stats(i) THEN
    IF stats(i)=1 THEN
	trigd=i*120
	SYSLOG "Input "+STR$(i+1)+" inactive."
    ENDIF
    IF stats(i)=0 THEN 
	trigd=i*120+60
	SYSLOG "Input "+STR$(i+1)+" active"
    ENDIF

	GOSUB 15
   oldstats(i)=stats(i)
 ENDIF
NEXT i
GOTO 1

15 'Report: Index in "trigd"
	'position in memory is defined by following lines
	OPEN "STP:"+STR$(200+trigd) AS 1
	READ 1, padr$
	CLOSE 1
	
100 'parse URL
proto=99
term$=CHR$(13)+CHR$(10) ' define termination character for UDP, TCP, serial
IF MID$(padr$,1,1) = "+" THEN term$=CHR$(10) : padr$=MID$(padr$,2): GOTO 150  ' define termination character for UDP, TCP, serial
IF MID$(padr$,1,1) = "=" THEN term$=CHR$(13) : padr$=MID$(padr$,2) : GOTO 150  ' define termination character for UDP, TCP, serial
IF MID$(padr$,1,1) = "-" THEN term$="" : padr$=MID$(padr$,2) : GOTO 150  ' define termination character for UDP, TCP, serial
150
IF MID$(padr$,1,6) ="udp://" THEN
   proto=1
   IF MID$(padr$,7,1)="(" THEN	'check for "(" in command string
     temp=INSTR(1,padr$,")")-8
     dlay=VAL(MID$(padr$,8,temp))   'extract delay value 
     padr$=MID$(padr$,temp+9)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,7)	'cut protocol info
   ENDIF
ENDIF
IF MID$(padr$,1,6) ="tcp://" THEN
   proto=3
   IF MID$(padr$,7,1)="(" THEN	'check for "(" in command string
     temp=INSTR(1,padr$,")")-8
     dlay=VAL(MID$(padr$,8,temp))   'extract delay value 
     padr$=MID$(padr$,temp+9)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,7)	'cut protocol info
   ENDIF
ENDIF
'	ptmp1=INSTR(1,padr$,"http://")
IF MID$(padr$,1,7) ="http://" THEN
   proto=0
   IF MID$(padr$,8,1) ="(" THEN
     temp=INSTR(1,padr$,")")-9
     dlay=VAL(MID$(padr$,9,temp))
     padr$=MID$(padr$,temp+10)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,8)	'cut protocol info
   ENDIF
ENDIF
IF MID$(padr$,1,8) ="rs232://" THEN
   proto=2
   IF MID$(padr$,9,1) ="(" THEN
     temp=INSTR(1,padr$,")")-10
'     dlay=VAL(MID$(padr$,10,temp))
     padr$=MID$(padr$,temp+11)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,9)	'cut protocol info
   ENDIF
ENDIF
IF MID$(padr$,1,8) ="rs485://" THEN
   proto=4
   IF MID$(padr$,9,1) ="(" THEN
     temp=INSTR(1,padr$,")")-10
'     dlay=VAL(MID$(padr$,10,temp))
     padr$=MID$(padr$,temp+11)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,9)	'cut protocol info
   ENDIF
ENDIF
IF MID$(padr$,1,8) ="local://" THEN
   proto=5
   IF MID$(padr$,9,1) ="(" THEN
     temp=INSTR(1,padr$,")")-10
'     dlay=VAL(MID$(padr$,10,temp))
     padr$=MID$(padr$,temp+11)	'cut protocol info, without protocol type and delays
     ELSE
       padr$=MID$(padr$,9)	'cut protocol info
   ENDIF
ENDIF
IF LEN(padr$)<1 THEN
   proto=6			'empty config field
   SYSLOG "empty config field",3
   RETURN
ENDIF



IF proto=99 THEN SYSLOG "Wrong protocol in URL" : RETURN
IF proto=2 THEN GOSUB 155 : RETURN   'if serial RS232
IF proto=4 THEN GOSUB 166 : RETURN   'if serial RS485
IF proto=5 THEN GOSUB 266 : RETURN   'if local command

ptmp1=INSTR(1,padr$,":")
ptmp2=INSTR(1,padr$,"/")
IF ptmp2=0 THEN ptmp2=LEN(padr$)-1
IF AND(ptmp1>0,ptmp1<ptmp2) THEN
	pport$=MID$(padr$,ptmp1+1,ptmp2-ptmp1-1)
	IF OR(proto=1,proto=3) THEN ppath$=MID$(padr$,ptmp2+1)
	IF proto=0 THEN ppath$=MID$(padr$,ptmp2)
	padr$=MID$(padr$,1,ptmp1-1)
	ELSE
		IF proto = 0 THEN
			pport$="80"
		        ELSE
			  SYSLOG "Error: Port must be specified for UDP protocol.",1
			  RETURN
		ENDIF
		IF proto=0 THEN ppath$=MID$(padr$,ptmp2)
                IF OR(proto=1,proto=3) THEN ppath$=MID$(padr$,ptmp2+1)
		padr$=MID$(padr$,1,ptmp2-1)
ENDIF
'send request
IF proto=0 THEN
	SYSLOG "Opening TCP:"+padr$+":"+pport$,3
	OPEN "TCP:"+padr$+":"+pport$ as 0
	t2=_TMR_(0)
	151   IF CONNECTED(0)=0 THEN          ' wait for the remote server
		IF _TMR_(0)-t2>(1000+dlay) THEN 
			SYSLOG "http server does not respond"
			IF MEDIATYPE(0)<>0 THEN CLOSE 0
			RETURN
		ENDIF
		GOTO 151
	      ENDIF
	      pos=INSTR(1,ppath$,"#26")
	      IF pos THEN
		s1$=MID$(ppath$,1,pos-1)
		s2$=MID$(ppath$,pos+3)
		ppath$=s1$+"&"+s2$
	      ENDIF
	      SYSLOG "sending GET..."+ppath$,2
	      buf$=""
	      WRITE 0, "GET "+ppath$+" HTTP/1.0\r\n\r\n"     
	      DELAY 50
	      READ 0,buf$,0
              SYSLOG "HTTP Response : "+buf$
  	      CLOSE 0
ENDIF


IF proto=1 THEN
	OPEN "UDP:"+padr$+":"+pport$ AS 0
	pos=INSTR(1,ppath$,"#26")
	IF pos THEN
	   s1$=MID$(ppath$,1,pos-1)
	   s2$=MID$(ppath$,pos+3)
	   ppath$=s1$+"&"+s2$
	ENDIF
	SYSLOG "0 | "+ ppath$+"| 0 |"+ padr$+" | "+ pport$,3
        IF dlay>0 THEN WRITE 0, "",0, padr$, val(pport$) : DELAY dlay
	ppath$=ppath$+term$
	buf$=""
	WRITE 0, ppath$,0, padr$, val(pport$)
	DELAY 50
	READ 0,buf$,0
        SYSLOG "UDP Response : "+buf$,2
	CLOSE 0
		
ENDIF
IF proto=3 THEN
	SYSLOG "Opening TCP:"+padr$+":"+pport$,3
	OPEN "TCP:"+padr$+":"+pport$ as 0
	t2=_TMR_(0)
	152   IF CONNECTED(0)=0 THEN          ' wait for the remote server
		IF _TMR_(0)-t2>(1000+dlay) THEN 
			SYSLOG "TCP server does not respond"
			IF MEDIATYPE(0)<>0 THEN CLOSE 0
			RETURN
		ENDIF
		GOTO 152
	      ENDIF
	      pos=INSTR(1,ppath$,"#26")
	      IF pos THEN
		s1$=MID$(ppath$,1,pos-1)
		s2$=MID$(ppath$,pos+3)
		ppath$=s1$+"&"+s2$-term$
	      ENDIF
	      SYSLOG "sending TCP message: "+ppath$,2
	      buf$=""
	      WRITE 0, ppath$ 
	      DELAY 50
	      READ 0,buf$,0
              SYSLOG "TCP Response : "+buf$
  	      CLOSE 0
ENDIF

dlay=0
RETURN

155  OPEN "COM::1" AS 0
SYSLOG "0 | Write RS232 message from input "+ STR$(201+i),2
pos=INSTR(1,padr$,"#26")
IF pos THEN
   s1$=padr$=MID$(padr$,1,pos-1)
   s2$=MID$(padr$,pos+3,b)
   padr$=s1$+"&"+s2$
ENDIF
padr$=padr$+term$
mlen=LEN(padr$)
buf$=""
SYSLOG "write RS232 message: "+padr$ ,9
WRITE 0, padr$, mlen
DELAY 50
READ 0,buf$,1
SYSLOG "RS232 Response : "+buf$,2
CLOSE 0
buf$=""
RETURN


166  OPEN "COM::2" AS 0
SYSLOG "0 | Write RS485 message from input "+ STR$(201+i),2
pos=INSTR(1,padr$,"#26")
IF pos THEN
   s1$=padr$=MID$(padr$,1,pos-1)
   s2$=MID$(padr$,pos+3,b)
   padr$=s1$+"&"+s2$
ENDIF
padr$=padr$+term$
mlen=LEN(padr$)
buf$=""
SYSLOG "write RS485 message: "+padr$ ,9
WRITE 0, padr$, mlen
DELAY 50
READ 0,buf$,1
SYSLOG "RS485 Response : "+buf$,2
CLOSE 0
buf$=""
RETURN




'--------------------------------------------------------------------------------
'excute local commands
'--------------------------------------------------------------------------------

266    msg$="wrong command: "+padr$+"\r"
   IF padr$ = "c=65535" then msg$="<BARIONET><NAME>Sensor</NAME></BARIONET>\r" 	' broadcast DISCOVER
      IF MID$(padr$,1,6) = "setio," THEN
         cp = INSTR(7,padr$,",")				' comma pos
         uu = VAL(MID$(padr$,7,cp-7))			' get register from request
         IOCTL uu,VAL(MID$(padr$,cp+1))			' set register
         IF err THEN msg$="state,err\r" ELSE msg$="state,"+STR$(uu)+","+STR$(IOSTATE(uu))+"\r" ' set reply
      ENDIF
      IF MID$(padr$,1,6) = "getio," THEN
         uu = VAL(MID$(padr$,7))
         IF err THEN msg$="state,err\r" ELSE msg$="state,"+STR$(uu)+","+STR$(IOSTATE(uu))+"\r" ' set reply
      ENDIF
		SYSLOG "System response from local:"+ msg$
    RETURN

